Package ghidra.program.model.data

# Class AbstractIntegerDataType

java.lang.Object
ghidra.program.model.data.AbstractDataType
ghidra.program.model.data.DataTypeImpl
ghidra.program.model.data.BuiltIn
ghidra.program.model.data.AbstractIntegerDataType

All Implemented Interfaces:
  `ArrayStringable`, `BuiltInDataType`, `DataType`, `ExtensionPoint`

Direct Known Subclasses:
  `AbstractSignedIntegerDataType`, `AbstractUnsignedIntegerDataType`, `CharDataType`

public abstract class AbstractIntegerDataType extends BuiltIn implements ArrayStringable
Base type for integer data types such as `chars`, `ints`, and `longs`.

If `FormatSettingsDefinition.getFormat(Settings)` indicates that this is a `CHAR` type, the `ArrayStringable` methods will treat an array of this data type as a string.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final EndianSettingsDefinition`
  `ENDIAN`
  `protected static final DataTypeMnemonicSettingsDefinition`
  `MNEMONIC`
  `protected static final PaddingSettingsDefinition`
  `PADDING`

  ### Fields inherited from class ghidra.program.model.data.DataTypeImpl

  `defaultSettings`

  ### Fields inherited from class ghidra.program.model.data.AbstractDataType

  `categoryPath, dataMgr, name`

  ### Fields inherited from interface ghidra.program.model.data.DataType

  `CONFLICT_SUFFIX, DEFAULT, NO_LAST_CHANGE_TIME, NO_SOURCE_SYNC_TIME, TYPEDEF_ATTRIBUTE_PREFIX, TYPEDEF_ATTRIBUTE_SUFFIX, VOID`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractIntegerDataType(String name, DataTypeManager dtm)`
  Constructor

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected BigInteger`
  `castValueToEncode(Object value)`
  `byte[]`
  `encodeRepresentation(String repr, MemBuffer buf, Settings settings, int length)`
  Encode bytes according to the display format for this type.
  `byte[]`
  `encodeValue(Object value, MemBuffer buf, Settings settings, int length)`
  Encode bytes from an Object appropriate for this DataType.
  `String`
  `getArrayDefaultLabelPrefix(MemBuffer buf, Settings settings, int len, DataTypeDisplayOptions options)`
  For cases where an array of this type exists, get the appropriate string to use as the default label prefix for the array.
  `String`
  `getArrayDefaultOffcutLabelPrefix(MemBuffer buf, Settings settings, int len, DataTypeDisplayOptions options, int offcutOffset)`
  For cases where an array of this type exists, get the appropriate string to use as the default label prefix, taking into account the fact that there exists a reference to the data that references `offcutLength` bytes into this type
  `String`
  `getAssemblyMnemonic()`
  `protected static int`
  `getBitCount(Class<? extends Number> type)`
  Get the number of bits in the integral type
  `protected SettingsDefinition[]`
  `getBuiltInSettingsDefinitions()`
  Gets a list of all the settingsDefinitions used by this datatype.
  `String`
  `getCDeclaration()`
  `String`
  `getCMnemonic()`
  `String`
  `getDefaultLabelPrefix()`
  Returns the appropriate string to use as the default label prefix in the absence of any data.
  `protected FormatSettingsDefinition`
  `getFormatSettingsDefinition()`
  Return the Format settings definition included in the settings definition array
  `String`
  `getMnemonic(Settings settings)`
  Get the mnemonic for this DataType.
  `abstract AbstractIntegerDataType`
  `getOppositeSignednessDataType()`
  `String`
  `getRepresentation(MemBuffer buf, Settings settings, int length)`
  Get bytes from memory in a printable format for this type.
  `static DataType`
  `getSignedDataType(int size, DataTypeManager dtm)`
  Get a Signed Integer data-type instance of the requested size
  `static AbstractIntegerDataType[]`
  `getSignedDataTypes(DataTypeManager dtm)`
  Returns all built-in signed integer data-types.
  `static DataType`
  `getUnsignedDataType(int size, DataTypeManager dtm)`
  Get a Unsigned Integer data-type instance of the requested size
  `static AbstractIntegerDataType[]`
  `getUnsignedDataTypes(DataTypeManager dtm)`
  Returns all built-in unsigned integer data-types
  `Object`
  `getValue(MemBuffer buf, Settings settings, int length)`
  Returns the interpreted data value as an instance of the `advertised value class`.
  `Class<?>`
  `getValueClass(Settings settings)`
  Get the Class of the value Object to be returned by this datatype (see `DataType.getValue(MemBuffer, Settings, int)`).
  `boolean`
  `hasStringValue(Settings settings)`
  For cases where an array of this type exists, determines if a String value will be returned.
  `boolean`
  `isEncodable()`
  Check if this type supports encoding (patching)
  `boolean`
  `isEquivalent(DataType dt)`
  Check if the given datatype is equivalent to this datatype.
  `abstract boolean`
  `isSigned()`
  Determine if this type is signed.

  ### Methods inherited from class ghidra.program.model.data.BuiltIn

  `addParent, copy, dataTypeDeleted, dataTypeNameChanged, dataTypeReplaced, dataTypeSizeChanged, dependsOn, getCTypeDeclaration, getCTypeDeclaration, getCTypeDeclaration, getCTypeDeclaration, getDecompilerDisplayName, getLastChangeTime, getSettingsDefinitions, getUniversalID, removeParent, setCategoryPath, setDefaultSettings, setName, setNameAndCategory`

  ### Methods inherited from class ghidra.program.model.data.DataTypeImpl

  `equals, getAlignedLength, getAlignment, getDefaultSettings, getLastChangeTimeInSourceArchive, getParents, getPathName, getSourceArchive, hashCode, notifyAlignmentChanged, notifyDeleted, notifyNameChanged, notifyParents, notifyReplaced, notifySizeChanged, replaceWith, setDescription, setLastChangeTime, setLastChangeTimeInSourceArchive, setSourceArchive`

  ### Methods inherited from class ghidra.program.model.data.AbstractDataType

  `dataTypeAlignmentChanged, getCategoryPath, getDataOrganization, getDataOrganization, getDataTypeManager, getDataTypePath, getDefaultAbbreviatedLabelPrefix, getDefaultLabelPrefix, getDefaultOffcutLabelPrefix, getDisplayName, getDocs, getName, getTypeDefSettingsDefinitions, hasLanguageDependantLength, isDeleted, isNotYetDefined, isZeroLength, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.program.model.data.ArrayStringable

  `getArrayString`

  ### Methods inherited from interface ghidra.program.model.data.DataType

  `addParent, clone, copy, dataTypeAlignmentChanged, dataTypeDeleted, dataTypeNameChanged, dataTypeReplaced, dataTypeSizeChanged, dependsOn, getAlignedLength, getAlignment, getCategoryPath, getDataOrganization, getDataTypeManager, getDataTypePath, getDefaultAbbreviatedLabelPrefix, getDefaultLabelPrefix, getDefaultOffcutLabelPrefix, getDefaultSettings, getDescription, getDisplayName, getDocs, getLastChangeTime, getLastChangeTimeInSourceArchive, getLength, getName, getParents, getPathName, getSettingsDefinitions, getSourceArchive, getTypeDefSettingsDefinitions, getUniversalID, hasLanguageDependantLength, isDeleted, isNotYetDefined, isZeroLength, removeParent, replaceWith, setCategoryPath, setDescription, setLastChangeTime, setLastChangeTimeInSourceArchive, setName, setNameAndCategory, setSourceArchive`

- ## Field Details

  - ### PADDING

    protected static final PaddingSettingsDefinition PADDING

  - ### ENDIAN

    protected static final EndianSettingsDefinition ENDIAN

  - ### MNEMONIC

    protected static final DataTypeMnemonicSettingsDefinition MNEMONIC

- ## Constructor Details

  - ### AbstractIntegerDataType

    public AbstractIntegerDataType(String name, DataTypeManager dtm)
    Constructor
    Parameters:
      `name` - a unique signed/unsigned data-type name (also used as the mnemonic)
      `dtm` - data-type manager whose data organization should be used

- ## Method Details

  - ### getFormatSettingsDefinition

    protected FormatSettingsDefinition getFormatSettingsDefinition()
    Return the Format settings definition included in the settings definition array
    Returns:
      Format settings definition included in the settings definition array
    See Also:
      - `BuiltIn.getSettingsDefinitions()`

  - ### getBuiltInSettingsDefinitions

    protected SettingsDefinition[] getBuiltInSettingsDefinitions()
    Description copied from class: `BuiltIn`
    Gets a list of all the settingsDefinitions used by this datatype.
    Overrides:
      `getBuiltInSettingsDefinitions` in class `BuiltIn`
    Returns:
      a list of the settingsDefinitions used by this datatype.

  - ### isSigned

    public abstract boolean isSigned()
    Determine if this type is signed.
    Returns:
      true if this is a signed integer data-type

  - ### getDefaultLabelPrefix

    public String getDefaultLabelPrefix()
    Description copied from interface: `DataType`
    Returns the appropriate string to use as the default label prefix in the absence of any data.
    Specified by:
      `getDefaultLabelPrefix` in interface `DataType`
    Overrides:
      `getDefaultLabelPrefix` in class `AbstractDataType`
    Returns:
      the default label prefix or null if none specified.

  - ### getMnemonic

    public String getMnemonic(Settings settings)
    Description copied from interface: `DataType`
    Get the mnemonic for this DataType.
    Specified by:
      `getMnemonic` in interface `DataType`
    Overrides:
      `getMnemonic` in class `AbstractDataType`
    Parameters:
      `settings` - settings which may influence the result or null
    Returns:
      the mnemonic for this DataType.

  - ### getAssemblyMnemonic

    public String getAssemblyMnemonic()
    Returns:
      the Assembly style data-type declaration for this data-type.

  - ### getCMnemonic

    public String getCMnemonic()
    Returns:
      the C style data-type mnemonic for this data-type. NOTE: currently the same as getCDeclaration().

  - ### getCDeclaration

    public String getCDeclaration()
    Returns:
      the C style data-type declaration for this data-type. Null is returned if no appropriate declaration exists.

  - ### getValue

    public Object getValue(MemBuffer buf, Settings settings, int length)
    Description copied from interface: `DataType`
    Returns the interpreted data value as an instance of the `advertised value class`.

    For instance, `Pointer` data types should return an Address object (or null), or integer data types should return a `Scalar` object.

    Specified by:
      `getValue` in interface `DataType`
    Parameters:
      `buf` - the data buffer
      `settings` - the settings to use.
      `length` - indicates the maximum number of bytes that may be consumed by a `Dynamic` datatype, otherwise this value is ignored. A value of -1 may be specified to allow a Dynamic datatype to determine the length based upon the actual data bytes
    Returns:
      the data object, or null if data is invalid

  - ### getBitCount

    protected static int getBitCount(Class<? extends Number> type)
    Get the number of bits in the integral type
    Parameters:
      `type` - the type
    Returns:
      the number of bits

  - ### castValueToEncode

    protected BigInteger castValueToEncode(Object value) throws DataTypeEncodeException
    Throws:
      `DataTypeEncodeException`

  - ### isEncodable

    public boolean isEncodable()
    Description copied from interface: `DataType`
    Check if this type supports encoding (patching)

    If unsupported, `DataType.encodeValue(Object, MemBuffer, Settings, int)` and `DataType.encodeRepresentation(String, MemBuffer, Settings, int)` will always throw an exception. Actions which rely on either `encode` method should not be displayed if the applicable datatype is not encodable.

    Specified by:
      `isEncodable` in interface `DataType`
    Overrides:
      `isEncodable` in class `AbstractDataType`
    Returns:
      true if encoding is supported

  - ### encodeValue

    public byte[] encodeValue(Object value, MemBuffer buf, Settings settings, int length) throws DataTypeEncodeException
    Description copied from interface: `DataType`
    Encode bytes from an Object appropriate for this DataType.

    Converts the given object to the byte encoding and returns it. When appropriate, this should seek the nearest encoding to the specified value, since the object may come from a user script. For example, a floating-point value may be rounded. Invalid values should be rejected with a `DataTypeEncodeException`.

    Specified by:
      `encodeValue` in interface `DataType`
    Overrides:
      `encodeValue` in class `AbstractDataType`
    Parameters:
      `value` - the desired value.
      `buf` - a buffer representing the eventual destination of the bytes.
      `settings` - the settings to use.
      `length` - the expected length of the result, usually the length of the data unit, or -1 to let the type choose the length. It may be ignored, e.g., for fixed-length types.
    Returns:
      the encoded value.
    Throws:
      `DataTypeEncodeException` - if the value cannot be encoded for any reason, e.g., incorrect type, not enough space, buffer overflow, unsupported (see `DataType.isEncodable()`).

  - ### getValueClass

    public Class<?> getValueClass(Settings settings)
    Description copied from interface: `DataType`
    Get the Class of the value Object to be returned by this datatype (see `DataType.getValue(MemBuffer, Settings, int)`).
    Specified by:
      `getValueClass` in interface `DataType`
    Overrides:
      `getValueClass` in class `DataTypeImpl`
    Parameters:
      `settings` - the relevant settings to use or null for default.
    Returns:
      Class of the value to be returned by this datatype or null if it can vary or is unspecified. Types which correspond to a string or char array will return the String class.

  - ### getRepresentation

    public String getRepresentation(MemBuffer buf, Settings settings, int length)
    Description copied from interface: `DataType`
    Get bytes from memory in a printable format for this type.
    Specified by:
      `getRepresentation` in interface `DataType`
    Parameters:
      `buf` - the data.
      `settings` - the settings to use for the representation.
      `length` - the number of bytes to represent.
    Returns:
      the representation of the data in this format, never null.

  - ### encodeRepresentation

    public byte[] encodeRepresentation(String repr, MemBuffer buf, Settings settings, int length) throws DataTypeEncodeException
    Description copied from interface: `DataType`
    Encode bytes according to the display format for this type.

    Converts the given representation to the byte encoding and returns it. When appropriate, this should seek the nearest encoding to the specified value, since the representation is likely coming from user input. For example, a floating-point value may be rounded. Invalid representations should be rejected with a `DataTypeEncodeException`.

    Specified by:
      `encodeRepresentation` in interface `DataType`
    Overrides:
      `encodeRepresentation` in class `AbstractDataType`
    Parameters:
      `repr` - the representation of the desired value, as in `DataType.getRepresentation(MemBuffer, Settings, int)`. The supported formats depend on the specific datatype and its settings.
      `buf` - a buffer representing the eventual destination of the bytes.
      `settings` - the settings to use for the representation.
      `length` - the expected length of the result, usually the length of the data unit, or -1 to let the type choose the length. It may be ignored, e.g., for fixed-length types.
    Returns:
      the encoded value.
    Throws:
      `DataTypeEncodeException` - if the value cannot be encoded for any reason, e.g., incorrect format, not enough space, buffer overflow, unsupported (see `DataType.isEncodable()`).

  - ### hasStringValue

    public boolean hasStringValue(Settings settings)
    Description copied from interface: `ArrayStringable`
    For cases where an array of this type exists, determines if a String value will be returned.

    Specified by:
      `hasStringValue` in interface `ArrayStringable`
    Returns:
      true if array of this type with the specified settings will return a String value.

  - ### getArrayDefaultLabelPrefix

    public String getArrayDefaultLabelPrefix(MemBuffer buf, Settings settings, int len, DataTypeDisplayOptions options)
    Description copied from interface: `ArrayStringable`
    For cases where an array of this type exists, get the appropriate string to use as the default label prefix for the array.
    Specified by:
      `getArrayDefaultLabelPrefix` in interface `ArrayStringable`
    Parameters:
      `buf` - memory buffer containing the bytes.
      `settings` - the Settings object
      `len` - the length of the data.
      `options` - options for how to format the default label prefix.
    Returns:
      the default label prefix or null if none specified.

  - ### getArrayDefaultOffcutLabelPrefix

    public String getArrayDefaultOffcutLabelPrefix(MemBuffer buf, Settings settings, int len, DataTypeDisplayOptions options, int offcutOffset)
    Description copied from interface: `ArrayStringable`
    For cases where an array of this type exists, get the appropriate string to use as the default label prefix, taking into account the fact that there exists a reference to the data that references `offcutLength` bytes into this type
    Specified by:
      `getArrayDefaultOffcutLabelPrefix` in interface `ArrayStringable`
    Parameters:
      `buf` - memory buffer containing the bytes.
      `settings` - the Settings object.
      `len` - the length of the data.
      `options` - options for how to format the default label prefix.
      `offcutOffset` - the length of the offcut label prefix.
    Returns:
      the default label prefix or null if none specified.

  - ### getOppositeSignednessDataType

    public abstract AbstractIntegerDataType getOppositeSignednessDataType()
    Returns:
      the data-type with the opposite signedness from this data-type. For example, this method on IntegerDataType will return an instance of UnsignedIntegerDataType.

  - ### isEquivalent

    public boolean isEquivalent(DataType dt)
    Description copied from interface: `DataType`
    Check if the given datatype is equivalent to this datatype.

    The precise meaning of "equivalent" is datatype dependent.
    NOTE: if invoked by a DB object or manager it should be invoked on the DataTypeDB object passing the other datatype as the argument.

    Specified by:
      `isEquivalent` in interface `DataType`
    Overrides:
      `isEquivalent` in class `BuiltIn`
    Parameters:
      `dt` - the datatype being tested for equivalence.
    Returns:
      true if the if the given datatype is equivalent to this datatype.

  - ### getSignedDataType

    public static DataType getSignedDataType(int size, DataTypeManager dtm)
    Get a Signed Integer data-type instance of the requested size
    Parameters:
      `size` - data type size, sizes greater than 8 (and other than 16) will cause an SignedByteDataType[size] (i.e., Array) to be returned.
      `dtm` - optional program data-type manager, if specified a generic data-type will be returned if possible.
    Returns:
      signed integer data type

  - ### getSignedDataTypes

    public static AbstractIntegerDataType[] getSignedDataTypes(DataTypeManager dtm)
    Returns all built-in signed integer data-types.
    Parameters:
      `dtm` - optional program data-type manager, if specified generic data-types will be returned in place of fixed-sized data-types.
    Returns:
      array of all signed integer types (char and bool types excluded)

  - ### getUnsignedDataType

    public static DataType getUnsignedDataType(int size, DataTypeManager dtm)
    Get a Unsigned Integer data-type instance of the requested size
    Parameters:
      `size` - data type size, sizes greater than 8 (and other than 16) will cause an undefined type to be returned.
      `dtm` - optional program data-type manager, if specified a generic data-type will be returned if possible.
    Returns:
      unsigned integer data type

  - ### getUnsignedDataTypes

    public static AbstractIntegerDataType[] getUnsignedDataTypes(DataTypeManager dtm)
    Returns all built-in unsigned integer data-types
    Parameters:
      `dtm` - optional program data-type manager, if specified generic data-types will be returned in place of fixed-sized data-types.
    Returns:
      array of all unsigned integer types (char and bool types excluded)